import { Collection } from 'mongodb';
import { IRecord } from '../interface/record';
import { IModelQuery } from '../interface/model-query';
import { IModelDefinition } from '../interface/model-definition';
import { IValidateResponse } from '../interface/validate-response';
export declare class AbstractModel {
    private definition;
    private collection;
    constructor(definition: IModelDefinition, collection: Collection);
    findOne(query: IModelQuery): Promise<IRecord | null>;
    find(query: IModelQuery): Promise<Array<IRecord>>;
    insertOne(record: IRecord): Promise<string>;
    insertMany(records: Array<IRecord>): Promise<Array<string> | string>;
    updateOne(query: IModelQuery, update: IRecord): Promise<boolean>;
    updateMany(query: IModelQuery, update: IRecord): Promise<boolean>;
    deleteOne(query: IModelQuery): Promise<boolean>;
    deleteMany(query: IModelQuery): Promise<boolean>;
    validate(record: IRecord): IValidateResponse;
}
