"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractModel = void 0;
var AbstractModel = (function () {
    function AbstractModel(definition, collection) {
        this.definition = definition;
        this.collection = collection;
    }
    AbstractModel.prototype.findOne = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.collection.findOne(query)];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    };
    AbstractModel.prototype.find = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.collection.find(query).toArray()];
                    case 1:
                        results = _a.sent();
                        return [2, results];
                }
            });
        });
    };
    AbstractModel.prototype.insertOne = function (record) {
        return __awaiter(this, void 0, void 0, function () {
            var result, result_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = this.validate(record);
                        if (!result.valid) return [3, 2];
                        return [4, this.collection.insertOne(record)];
                    case 1:
                        result_1 = _a.sent();
                        return [2, result_1.insertedId];
                    case 2: return [2, String(result.reason)];
                }
            });
        });
    };
    AbstractModel.prototype.insertMany = function (records) {
        return __awaiter(this, void 0, void 0, function () {
            var index, result_2, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        for (index in records) {
                            result_2 = this.validate(records[index]);
                            if (!result_2.valid)
                                return [2, String(result_2.reason)];
                        }
                        return [4, this.collection.insertMany(records)];
                    case 1:
                        result = _a.sent();
                        return [2, Object.values(result.insertedIds)];
                }
            });
        });
    };
    AbstractModel.prototype.updateOne = function (query, update) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.collection.updateOne(query, { $set: update }, { upsert: true })];
                    case 1:
                        result = _a.sent();
                        return [2, (result.result.ok === 1 ? true : false)];
                }
            });
        });
    };
    AbstractModel.prototype.updateMany = function (query, update) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.collection.updateMany(query, { $set: update }, { upsert: true })];
                    case 1:
                        result = _a.sent();
                        return [2, (result.result.ok === 1 ? true : false)];
                }
            });
        });
    };
    AbstractModel.prototype.deleteOne = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.collection.deleteOne(query)];
                    case 1:
                        result = _a.sent();
                        return [2, (result.result.ok === 1 ? true : false)];
                }
            });
        });
    };
    AbstractModel.prototype.deleteMany = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.collection.deleteMany(query)];
                    case 1:
                        result = _a.sent();
                        return [2, (result.result.ok === 1 ? true : false)];
                }
            });
        });
    };
    AbstractModel.prototype.validate = function (record) {
        for (var key in record) {
            var definition = (typeof this.definition.fields[key] !== 'undefined' ? this.definition.fields[key] : false);
            if (definition !== false) {
                if (typeof record[key] !== definition.replace('?', '')) {
                    return { valid: false, reason: "The key: " + key + " should be of type: " + definition.replace('?', '') + ", not type: " + typeof record[key] + "." };
                }
            }
            else {
                return { valid: false, reason: "The key: " + key + ", does not exist on this model." };
            }
        }
        for (var fkey in this.definition.fields) {
            if (typeof record[fkey] === 'undefined' && String(this.definition.fields[fkey]).charAt(0) !== '?') {
                return { valid: false, reason: "Missing model key: " + fkey + "." };
            }
        }
        return { valid: true };
    };
    return AbstractModel;
}());
exports.AbstractModel = AbstractModel;
//# sourceMappingURL=model.js.map