"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectModel = void 0;
function InjectModel(modelNames) {
    return function (target) {
        if (!Reflect.hasMetadata('models', target)) {
            Reflect.defineMetadata('models', [], target);
        }
        var models = Reflect.getMetadata('models', target);
        if (typeof modelNames === 'string') {
            models.push(modelNames);
        }
        else {
            models.push.apply(models, modelNames);
        }
        Reflect.defineMetadata('models', models, target);
    };
}
exports.InjectModel = InjectModel;
//# sourceMappingURL=inject-model.js.map