"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Route = void 0;
function Route(method, path) {
    return function (target, propertyKey) {
        if (!Reflect.hasMetadata('routes', target.constructor)) {
            Reflect.defineMetadata('routes', [], target.constructor);
        }
        var routes = Reflect.getMetadata('routes', target.constructor);
        routes.push({
            requestMethod: method.toLowerCase(),
            path: path,
            methodName: propertyKey,
        });
        Reflect.defineMetadata('routes', routes, target.constructor);
    };
}
exports.Route = Route;
//# sourceMappingURL=route.js.map