import * as express from 'express';
import { IOptions } from '../interface/options';
export declare class Server {
    protected options: IOptions;
    protected server: any;
    protected controllers: Array<any>;
    protected models: Array<any>;
    protected availableModels: any;
    protected client: any;
    protected database: any;
    constructor(options: IOptions);
    init(): Promise<any>;
    setupDatabase(shouldAuth?: boolean): Promise<void>;
    start(): Promise<void>;
    private processModels;
    private processControllers;
    registerControllers(controllers: Array<any>): void;
    registerModels(models: Array<any>): void;
    registerMiddleware(middleware: (request: express.Request, response: express.Response, next: express.NextFunction) => void): void;
}
