"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Server = void 0;
var express = require("express");
var cookieParser = require("cookie-parser");
var bodyParser = require("body-parser");
var mongodb_1 = require("mongodb");
var Server = (function () {
    function Server(options) {
        this.options = options;
        this.controllers = [];
        this.models = [];
        this.availableModels = {};
        this.server = express();
        this.server.use(cookieParser());
        this.server.use(bodyParser.urlencoded({ extended: true }));
        this.server.use(bodyParser.json());
    }
    Server.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.options.database && this.options.db_port && this.options.hostname)) return [3, 4];
                        if (!(this.options.username && this.options.password)) return [3, 2];
                        return [4, this.setupDatabase(true)];
                    case 1:
                        _a.sent();
                        return [3, 4];
                    case 2: return [4, this.setupDatabase(false)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2];
                }
            });
        });
    };
    Server.prototype.setupDatabase = function (shouldAuth) {
        if (shouldAuth === void 0) { shouldAuth = false; }
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        var context = _this;
                        var database_uri;
                        if (shouldAuth) {
                            database_uri = "mongodb://" + _this.options.username + ":" + _this.options.password + "@" + _this.options.hostname + ":" + _this.options.db_port + "/" + _this.options.database;
                        }
                        else {
                            database_uri = "mongodb://" + _this.options.hostname + ":" + _this.options.db_port + "/" + _this.options.database;
                        }
                        mongodb_1.MongoClient.connect(database_uri, {
                            useUnifiedTopology: true,
                            useNewUrlParser: true,
                        }, function (err, client) {
                            if (err)
                                reject("Failed to connect to database, code: " + err.code + " and message: " + err.message + ".");
                            context.client = client;
                            resolve(true);
                        });
                    })];
            });
        });
    };
    Server.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.processModels()];
                    case 1:
                        _a.sent();
                        return [4, this.processControllers()];
                    case 2:
                        _a.sent();
                        this.server.listen(this.options.port, function () {
                            console.log('Aether Server, listening on port: ' + _this.options.port);
                        });
                        return [2];
                }
            });
        });
    };
    Server.prototype.processModels = function () {
        return __awaiter(this, void 0, void 0, function () {
            var index, definition;
            return __generator(this, function (_a) {
                for (index in this.models) {
                    definition = Reflect.getMetadata('model', this.models[index]);
                    this.database = this.client.db(this.options.database);
                    this.availableModels[definition.collection] = new this.models[index](definition, this.database.collection(definition.collection));
                }
                return [2];
            });
        });
    };
    Server.prototype.processControllers = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.controllers.forEach(function (controller) {
                    var instance = new controller();
                    var prefix = Reflect.getMetadata('prefix', controller);
                    var routes = Reflect.getMetadata('routes', controller);
                    var models = Reflect.getMetadata('models', controller);
                    for (var index in models) {
                        if (typeof _this.availableModels[models[index]] !== 'undefined') {
                            instance.models[models[index]] = _this.availableModels[models[index]];
                        }
                    }
                    routes.forEach(function (route) {
                        _this.server[route.requestMethod](prefix + route.path, function (request, response) { return __awaiter(_this, void 0, void 0, function () {
                            var headers, index, query, index, params, index, cookies, index, context, result;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        headers = {};
                                        for (index in request.headers) {
                                            headers[index] = request.headers[index];
                                        }
                                        query = {};
                                        for (index in request.query) {
                                            query[index] = request.query[index];
                                        }
                                        params = {};
                                        for (index in request.params) {
                                            params[index] = request.params[index];
                                        }
                                        cookies = {};
                                        for (index in request.cookies) {
                                            cookies[index] = request.cookies[index];
                                        }
                                        context = {
                                            httpVersion: request.httpVersion,
                                            headers: headers,
                                            requestedUrl: request.url,
                                            httpMethod: request.method,
                                            ipAddress: request.socket.remoteAddress || '',
                                            params: params,
                                            query: query,
                                            cookies: cookies,
                                            body: request.body,
                                            setCookie: function (name, value, maxAge, httpOnly, secure) {
                                                var cookieParams = {};
                                                if (maxAge)
                                                    cookieParams.maxAge = (1000 * 86400 * maxAge);
                                                if (httpOnly)
                                                    cookieParams.httpOnly = httpOnly;
                                                if (secure)
                                                    cookieParams.secure = secure;
                                                response.cookie(name, value, cookieParams);
                                                return true;
                                            }
                                        };
                                        return [4, instance[route.methodName](context)];
                                    case 1:
                                        result = _a.sent();
                                        response.status(result.status).send(result.content);
                                        return [2];
                                }
                            });
                        }); });
                    });
                });
                return [2];
            });
        });
    };
    Server.prototype.registerControllers = function (controllers) {
        for (var index in controllers) {
            this.controllers.push(controllers[index]);
        }
    };
    Server.prototype.registerModels = function (models) {
        for (var index in models) {
            this.models.push(models[index]);
        }
    };
    Server.prototype.registerMiddleware = function (middleware) {
        this.server.use(middleware);
    };
    return Server;
}());
exports.Server = Server;
//# sourceMappingURL=server.js.map