export function InjectModel(modelNames: Array<string> | string): any {
	return (target: any) => {
		if (!Reflect.hasMetadata('models', target)) {
			Reflect.defineMetadata('models', [], target);
		}
		const models: Array<any> = Reflect.getMetadata('models', target);
		if (typeof modelNames === 'string') {
			models.push(modelNames);
		} else {
			models.push(...modelNames);
		}
		Reflect.defineMetadata('models', models, target);
	}
}