export function Route(method: string, path: string): any {
	return (target: any, propertyKey: string): void => {
		if (!Reflect.hasMetadata('routes', target.constructor)) {
			Reflect.defineMetadata('routes', [], target.constructor);
		}
		const routes: Array<any> = Reflect.getMetadata('routes', target.constructor);
		routes.push({
			requestMethod: method.toLowerCase(),
			path,
			methodName: propertyKey,
		});
		Reflect.defineMetadata('routes', routes, target.constructor);
	}
}